#include <graphics.h>    // graphics library declarations
#include <conio.h>       // for getch() function
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>

/* constants */
#define NUMBULLETS 10
#define NUMSTARS 500
#define NUMASTEROIDS 10
#define NUMLIVES = 3
#define SHIPIMAGE "h:/tc/rocket.bmp"
#define BULLETIMAGE "h:/tc/bullet.bmp"
#define ASIMAGE "h:/tc/asteroid.bmp"

/* type definitions */
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

typedef struct tagBITMAP              /* the structure for a bitmap. */
{
  word width;
  word height;
  byte *data;
} BITMAP;

/* function prototypes */
void load_bmp(char *file,BITMAP *b);
int play(void);
void fskip(FILE *fp, int num_bytes);
void draw_bitmap(BITMAP *bmp,int x,int y);
int collision(void);
void ShowScore(void);

/* The Background Object */
class Background {
public:
	int stars[NUMSTARS][2];
	Background(int);
	Move(void);
};

/* The Bullet Object */
class Bullet {
public:
	int X, Y, oldX, oldY;
	int XSpeed, YSpeed, Visible;
	int Size, numBullets;
	Bullet();
	Add();
	void Draw(void);
	void Move(void);
	BITMAP bmp;
};

/* The Ship Object */
class Ship {
public:
	int X, Y, oldX, oldY, XSpeed, YSpeed, Size;
	Ship(int, int, char *file);
	void Draw(void);
	void Move(void);
	BITMAP bmp;
};

/* The Asteroid object */
class Asteroid {
public:
	int X, Y, oldX, oldY, XSpeed, YSpeed, Size, Visible;
	Asteroid(void);
	Init(void);
	void Draw(void);
	void Move(void);
	BITMAP bmp;
};

class Scoreboard{
public:
	Scoreboard(int l, int x, int y);
	Update(void);
	int X, Y, Lives, oldLives, Shots, oldShots, Hits, oldHits, Score, oldScore;
};

Ship Ship1(100,200,SHIPIMAGE);
Bullet Bull[NUMBULLETS];
Asteroid A1[NUMASTEROIDS];
Scoreboard S1(2,250,1);
BITMAP asbmp;

main()                        // test the functions
{
	// initialize the graphics system
	int graphdriver = DETECT, graphmode, c, count, a;
	initgraph(&graphdriver, &graphmode, "H:/tc/");
	Background Backgrnd(0);
	for(c=0; c<NUMASTEROIDS; c++)
		A1[c].Visible=0;
	flushall();
	for(c=0; c<NUMBULLETS; c++)
		Bull[c].Visible=0;
	count = random(10)+1;
	c=0;
	load_bmp(ASIMAGE,&asbmp);
	while(play())
	{
		S1.Update();
		Backgrnd.Move();
		c++;
		if(c == count)
		{
			c=0;
			count = random(100)+1;
			for(a=0; a<NUMASTEROIDS; a++)
				if(!A1[a].Visible)
				{
					A1[a].Init();
					break;
				}
		}
	}
	ShowScore();
	closegraph();
}

int play(void)
{
	char key;
	int c;

	flushall();
	for(c=0; c<NUMASTEROIDS; c++)
	{
		A1[c].Draw();
		A1[c].Move();
	}
	for(c=0; c<NUMBULLETS; c++)
	{
		Bull[c].Draw();
		Bull[c].Move();
	}
	//delay(10);
	flushall();
	Ship1.Draw();
	flushall();
	Ship1.Move();
	flushall();
	if(kbhit())
	{
		key = getch();
		flushall();
		if(key == 'H')
			Ship1.YSpeed --;
		else if(key == 'P')
			Ship1.YSpeed ++;
		else if(key == 'M')
			Ship1.XSpeed ++;
		else if(key == 'K')
			Ship1.XSpeed --;
		else if(key == ' ')
		{
			for(c=0; c<NUMBULLETS; c++)
				if(!Bull[c].Visible)
				{
					Bull[c].Add();
					break;
				}
			S1.Shots++;
		}
		else if(key == 'q')
			return 0;
	}
	flushall();
	if(collision())
	{
		if(S1.Lives == 0)
			return 0;
		else
			S1.Lives--;
	}
	flushall();
	return 1;
}

void load_bmp(char *file,BITMAP *b)
{
  FILE *fp;
  long index;
  word num_colors;
  int x;

  /* open the file */
  if ((fp = fopen(file,"rb")) == NULL)
  {
	 printf("Error opening file %s.\n",file);
	 exit(1);
  }

  /* check to see if it is a valid bitmap file */
  if (fgetc(fp)!='B' || fgetc(fp)!='M')
  {
	 fclose(fp);
	 printf("%s is not a bitmap file.\n",file);
	 exit(1);
  }

  /* read in the width and height of the image, and the
	  number of colors used; ignore the rest */
  fskip(fp,16);
  fread(&b->width, sizeof(word), 1, fp);
  fskip(fp,2);
  fread(&b->height,sizeof(word), 1, fp);
  fskip(fp,22);
  fread(&num_colors,sizeof(word), 1, fp);
  fskip(fp,6);

  /* assume we are working with an 8-bit file */
  if (num_colors==0) num_colors=256;


  /* try to allocate memory */
  if ((b->data = (byte *) malloc((word)(b->width*b->height))) == NULL)
  {
	 fclose(fp);
	 printf("Error allocating memory for file %s.\n",file);
	 exit(1);
  }

  /* Ignore the palette information for now.
	  See palette.c for code to read the palette info. */
  fskip(fp,num_colors*4);

  /* read the bitmap */
  for(index=(b->height-1)*b->width;index>=0;index-=b->width)
	 for(x=0;x<b->width;x++)
		b->data[(word)index+x]=(byte)fgetc(fp);

  fclose(fp);
}

void fskip(FILE *fp, int num_bytes)
{
	int i;
	for (i=0; i<num_bytes; i++)
		fgetc(fp);
}

void draw_bitmap(BITMAP *bmp,int x,int y)
{
	int row, col;
	for(row=0; row<bmp->height; row++)
		for(col=0; col<bmp->width; col++)
			//if(bmp->data[(row*bmp->width)+col])
				putpixel(x+col,y+row,bmp->data[(row*bmp->width)+col]);
}

int collision(void)
{
	int acount, bcount;

	for(acount=0; acount<NUMASTEROIDS; acount++)
	{
		for(bcount=0; bcount<NUMBULLETS; bcount++)
			if(Bull[bcount].Visible && A1[acount].Visible && (Bull[bcount].X >= A1[acount].X) && (Bull[bcount].X <= A1[acount].X+asbmp.width) && (Bull[bcount].Y >= A1[acount].Y) && (Bull[bcount].Y <= A1[acount].Y+asbmp.height))
			{
				Bull[bcount].Visible = 0;
				A1[acount].Visible = 0;
				setcolor(0);
				bar(A1[acount].X-20,A1[acount].Y-20,A1[acount].X+asbmp.width+20,A1[acount].Y+asbmp.height+20);
				S1.Hits ++;
			}
		if(A1[acount].Visible && (A1[acount].X >= Ship1.X-asbmp.width+10) && (A1[acount].X <= Ship1.X+Ship1.bmp.width-10) && (A1[acount].Y >= Ship1.Y-asbmp.height+10) && (A1[acount].Y <= Ship1.Y+Ship1.bmp.height-10))
		{
			A1[acount].Visible = 0;
			setcolor(0);
			bar(A1[acount].X-10,A1[acount].Y-10,A1[acount].X+asbmp.width+10,A1[acount].Y+asbmp.height+10);
			return 1;
		}
	}
	return 0;
}

void ShowScore(void)
{
	char *output;
	cleardevice();
	flushall();
	setcolor(WHITE);
	sprintf(output, "Shots: %d    Hits: %d    SCORE: %d", S1.Shots, S1.Hits, S1.Score);
	outtextxy(200,200,output);
	outtextxy(250,220,"press ENTER to quit");
	gets(output);
}

/* The Background object's functions */

Background::Background(int d)
{
	int c;
	randomize();
	for(c=0; c<NUMSTARS; c++)
	{
		stars[c][0] = random(getmaxx());
		stars[c][1] = random(getmaxy()+1);
	}
}

Background::Move()
{
	int c;
	for(c = 0; c < NUMSTARS; c++)
	{
		if(getpixel(stars[c][0],stars[c][1]) == 15)
			putpixel(stars[c][0],stars[c][1],0);
		stars[c][0] --;
		if(stars[c][0] < 0)
		{
			stars[c][0] = getmaxx();
			stars[c][1] = random(getmaxy()+1);
		}
		if(!getpixel(stars[c][0],stars[c][1]))
			putpixel(stars[c][0],stars[c][1],15);
	}
}

/* The Bullet object's functions */

Bullet::Bullet()
{
};

void Bullet::Draw(void)
{
	int c;
	// draw the new bullet
	if(Visible)
	{
		setfillstyle(SOLID_FILL,0);
		fillellipse(oldX,oldY,3,3);
		setfillstyle(SOLID_FILL,RED);
		fillellipse(X,Y,3,3);
	}
}

void Bullet::Move(void)
{
	int c;
	oldX=X;
	oldY=Y;
	X += XSpeed;
	Y += YSpeed;

	if(X > getmaxx() || Y > getmaxy() || Y < 0)
	{
		Visible = 0;
		setfillstyle(SOLID_FILL,0);
		fillellipse(oldX,oldY,3,3);
	}
}

Bullet::Add()
{
	X = Ship1.X + Ship1.Size - 5;
	Y = Ship1.Y + Ship1.bmp.height/3;
	XSpeed = 10 + Ship1.XSpeed;
	YSpeed = Ship1.YSpeed;
	Visible = 1;
}

/* The Ship object's functions */

Ship::Ship(int x, int y, char *file)
{
	X = x;
	Y = y;
	oldX=X;
	oldY=Y;
	load_bmp(file,&bmp);
	Size = bmp.width;
};

void Ship::Draw(void)
{
	// cover over the old ship
	setcolor(0);
	setfillstyle(SOLID_FILL, 0);
	if(X == oldX && Y < oldY)  // straight up
		bar(X, Y+bmp.height, X+bmp.width, oldY+bmp.height);
	else if(X == oldX && Y > oldY)  // straight down
		bar(X, oldY, X+bmp.width, Y);
	else if(X < oldX && Y == oldY) // straight left
		bar(X+bmp.width, Y, oldX+bmp.width, Y+bmp.height);
	else if(X > oldX && Y == oldY) // straight right
		bar(oldX, Y, X, Y+bmp.height);
	else if(X > oldX && Y > oldY) // down and right
	{
		bar(oldX, oldY, oldX+bmp.width, Y);
		bar(oldX, Y, X, oldY+bmp.height);
	}
	else if(X > oldX && Y < oldY) // up and right
	{
		bar(oldX, oldY, X, oldY+bmp.height);
		bar(X, Y+bmp.height, oldX+bmp.width, oldY+bmp.height);
	}
	else if(X < oldX && Y < oldY) // up and left
	{
		bar(X+bmp.width, oldY, oldX+bmp.width, oldY+bmp.height);
		bar(oldX, Y+bmp.height, X+bmp.width, oldY+bmp.height);
	}
	else if(X < oldX && Y > oldY) // down and left
	{
		bar(oldX, oldY, oldX+bmp.width, Y);
		bar(X+bmp.width, Y, oldX+bmp.width, oldY+bmp.width);
	}


	// draw the new ship
	draw_bitmap(&bmp,X,Y);
}

void Ship::Move(void)
{
	oldX=X;
	oldY=Y;
	X += XSpeed;
	Y += YSpeed;

	if(X > (getmaxx()/2)-Size)
	{
		X = (getmaxx()/2)-Size;
		XSpeed=0;
	}
	if(X < 0)
	{
		X = 0;
		XSpeed=0;
	}
	if(Y > getmaxy()) Y=0-(int)bmp.height;
	if(Y < 0-(int)bmp.height) Y=getmaxy();
}

/* The Asteroid object's functions */

Asteroid::Asteroid()
{
};

void Asteroid::Draw(void)
{
	// cover over the old asteroid
	if(Visible)
	{
		setcolor(0);
		setfillstyle(SOLID_FILL, 0);
		if(X == oldX && Y < oldY)  // straight up
			bar(X, Y+asbmp.height, X+asbmp.width, oldY+asbmp.height);
		else if(X == oldX && Y > oldY)  // straight down
			bar(X, oldY, X+asbmp.width, Y);
		else if(X < oldX && Y == oldY) // straight left
			bar(X+asbmp.width, Y, oldX+asbmp.width, Y+asbmp.height);
		else if(X > oldX && Y == oldY) // straight right
			bar(oldX, Y, X, Y+asbmp.height);
		else if(X > oldX && Y > oldY) // down and right
		{
			bar(oldX, oldY, oldX+asbmp.width, Y);
			bar(oldX, Y, X, oldY+asbmp.height);
		}
		else if(X > oldX && Y < oldY) // up and right
		{
			bar(oldX, oldY, X, oldY+asbmp.height);
			bar(X, Y+asbmp.height, oldX+asbmp.width, oldY+asbmp.height);
		}
		else if(X < oldX && Y < oldY) // up and left
		{
			bar(X+asbmp.width, oldY, oldX+asbmp.width, oldY+asbmp.height);
			bar(oldX, Y+asbmp.height, X+asbmp.width, oldY+asbmp.height);
		}
		else if(X < oldX && Y > oldY) // down and left
		{
			bar(oldX, oldY, oldX+asbmp.width, Y);
			bar(X+asbmp.width, Y, oldX+asbmp.width, oldY+asbmp.width);
		}


	// draw the new asteroid
		draw_bitmap(&asbmp,X,Y);
	}
}

void Asteroid::Move(void)
{
	oldX=X;
	oldY=Y;
	XSpeed=random(11)-10;
	X += XSpeed;
	Y += YSpeed;
	if(Y > getmaxy()) Y=0-(int)asbmp.height;
	if(Y < 0-(int)asbmp.height) Y = getmaxy();
	if(X < 0-(int)asbmp.height)
	{
		Visible = 0;
		setcolor(0);
		bar(oldX,oldY,oldX+asbmp.width,oldY+asbmp.height);
	}
}

Asteroid::Init()
{
	Visible = 1;
	X=getmaxx();
	Y=random(getmaxy());
	YSpeed=random(21)-10;
};

// The Scoreboard object's functions

Scoreboard::Scoreboard(int l, int x, int y)
{
	Lives = l;
	oldLives = Lives;
	X = x;
	Y = y;
}
Scoreboard::Update(void)
{
	char *output;
	Score = 10*Hits - (Shots-Hits) - 5*(oldLives-Lives);
	setcolor(BLACK);
	bar(X,Y,getmaxx(),Y+10);
	setcolor(WHITE);
	sprintf(output, "Lives: %d   Shots: %d   Hits: %d   Score: %d", Lives, Shots, Hits, Score);
	outtextxy(X,Y,output);
}
