#include <graphics.h>    // graphics library declarations
#include <conio.h>       // for getch() function
#include <stdio.h>
#include <stdlib.h>

/* constants */
#define SHIPIMAGE "h:/tc/rocket.bmp"

/* type definitions */
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;
typedef struct tagBITMAP              /* the structure for a bitmap. */

{
word width;
word height;
byte *data;
} BITMAP;

// --------------------------function prototypes------------------------------
void load_bmp(char *file,BITMAP *b);
int move_bmp(int x, int y);
int play(void);
void fskip(FILE *fp, int num_bytes);
void draw_bitmap(BITMAP *bmp,int x,int y);
char *file;
BITMAP bmp;

//----------------------------------main------------------------------------------
main()                        // test the functions
{
//----------------------------------initgraph--------------------------------------
int graphdriver = DETECT, graphmode;
initgraph(&graphdriver, &graphmode, "C:/tc/bgi");
flushall();
play();
getch();
closegraph();
return(0);
}

//-------------------------------------play-----------------------------------------
int play(void)
{
int x=getmaxx()/2;
int y=getmaxy()/2;
//delay(10);
load_bmp("H:/TC/rocket.bmp",&bmp);
setfillstyle(SOLID_FILL,getmaxcolor());
bar(0,0,getmaxx(),getmaxy());
draw_bitmap(&bmp,getmaxx()/2,getmaxy()/2);
move_bmp(x,y);
return(0);
}
//----------------------------------move_bmp------------------------------------------
int move_bmp(int x, int y)
{
	char *z="\0";
	while(1)
	{
		*z=getch();
		if (*z=='q'||*z=='Q')
			exit(1);
		else
		{
			if(*z=='P'){
				y+=2;
				}
			if(*z=='H'){
				y-=2;
				}
			if(*z=='M'){
				x+=2;
				}
			if(*z=='K'){
				x-=2;
				}
			draw_bitmap(&bmp,x,y);
		}
	}
}
//----------------------------------load_bmp------------------------------------------
void load_bmp(char *file,BITMAP *b)
{
FILE *fp;
long index;
word num_colors;
int x;


/* open the file */
if ((fp = fopen(file,"rb")) == NULL)
{
printf("Error opening file %s.\n",file);
exit(1);
}


/* check to see if it is a valid bitmap file */
if (fgetc(fp)!='B' || fgetc(fp)!='M')
{
fclose(fp);
printf("%s is not a bitmap file.\n",file);
exit(1);
}


/* read in the width and height of the image, and the number of colors used; ignore the rest */
fskip(fp,16);
fread(&b->width, sizeof(word), 1, fp);
fskip(fp,2);
fread(&b->height,sizeof(word), 1, fp);
fskip(fp,22);
fread(&num_colors,sizeof(word), 1, fp);
fskip(fp,6);


/* assume we are working with an 8-bit file */
if (num_colors==0) num_colors=256;


/* try to allocate memory */
if ((b->data = (byte *) malloc((word)(b->width*b->height))) == NULL)
{
fclose(fp);
printf("Error allocating memory for file %s.\n",file);
exit(1);
}


fskip(fp,num_colors*4);
/* read the bitmap */
for(index=(b->height-1)*b->width;index>=0;index-=b->width)
for(x=0;x<b->width;x++)
b->data[(word)index+x]=(byte)fgetc(fp);
fclose(fp);
}

//-------------------------------------fskip-------------------------------------------
void fskip(FILE *fp, int num_bytes)
{
int i;
for (i=0; i<num_bytes; i++)
fgetc(fp);
}

//------------------------------------draw_bitmap---------------------------------------
void draw_bitmap(BITMAP *bmp,int x,int y)
{
int row, col;
for(row=0; row<bmp->height; row++)
for(col=0; col<bmp->width; col++)
//if(bmp->data[(row*bmp->width)+col])
putpixel(x+col,y+row,bmp->data[(row*bmp->width)+col]);

}

