#include <graphics.h>    // graphics library declarations
#include <conio.h>       // for getch() function
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>


//------------------------- constant---------------------------
#define SHIPIMAGE "h:/tc/rocket.bmp"

//---------------------- type definitions ---------------------
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

typedef struct tagBITMAP              /* the structure for a bitmap. */
{
  word width;
  word height;
  byte *data;
} BITMAP;

//------------------- function prototypes ----------------------
void load_bmp(char *file,BITMAP *b);
int play(void);
void fskip(FILE *fp, int num_bytes);
void draw_bitmap(BITMAP *bmp,int x,int y);

//--------------------- The Ship Object -----------------------
class Ship {
public:
	int X, Y, oldX, oldY, XSpeed, YSpeed, Size;
	Ship(int, int, char *file);
	void Draw(void);
	void Move(void);
	BITMAP bmp;
};
//---------------------- instance ------------------------------
Ship Ship1(1,1,SHIPIMAGE);
main()
{
//---------------------- initgraph -----------------------------
	int graphdriver = DETECT, graphmode, c;
	initgraph(&graphdriver, &graphmode, "C:/tc/bgi");
	flushall();
	while(play())
	{
	}
	closegraph();
	return 0;
}

//-------------------------- play ------------------------------
int play(void)
{
	char key;
	int c;

	Ship1.Draw();
	Ship1.Move();
	if(kbhit())
	{
		key = getch();
		if(key == 'H')
			Ship1.YSpeed --;
		else if(key == 'P')
			Ship1.YSpeed ++;
		else if(key == 'M')
			Ship1.XSpeed ++;
		else if(key == 'K')
			Ship1.XSpeed --;
		else if(key == 'q')
			return 0;
		flushall();
	}
	return 1;
}
//--------------------------- load bitmap ---------------------------
void load_bmp(char *file,BITMAP *b)
{
  FILE *fp;
  long index;
  word num_colors;
  int x;

  /* open the file */
  if ((fp = fopen(file,"rb")) == NULL)
  {
	 printf("Error opening file %s.\n",file);
	 exit(1);
  }

  /* check to see if it is a valid bitmap file */
  if (fgetc(fp)!='B' || fgetc(fp)!='M')
  {
	 fclose(fp);
	 printf("%s is not a bitmap file.\n",file);
	 exit(1);
  }

  /* read in the width and height of the image, and the
	  number of colors used; ignore the rest */
  fskip(fp,16);
  fread(&b->width, sizeof(word), 1, fp);
  fskip(fp,2);
  fread(&b->height,sizeof(word), 1, fp);
  fskip(fp,22);
  fread(&num_colors,sizeof(word), 1, fp);
  fskip(fp,6);

  /* assume we are working with an 8-bit file */
  if (num_colors==0) num_colors=256;


  /* try to allocate memory */
  if ((b->data = (byte *) malloc((word)(b->width*b->height))) == NULL)
  {
	 fclose(fp);
	 printf("Error allocating memory for file %s.\n",file);
	 exit(1);
  }

  fskip(fp,num_colors*4);

  /* read the bitmap */
  for(index=(b->height-1)*b->width;index>=0;index-=b->width)
	 for(x=0;x<b->width;x++)
		b->data[(word)index+x]=(byte)fgetc(fp);

  fclose(fp);
}

void fskip(FILE *fp, int num_bytes)
{
	int i;
	for (i=0; i<num_bytes; i++)
		fgetc(fp);
}

void draw_bitmap(BITMAP *bmp,int x,int y)
{
	int row, col;
	for(row=0; row<bmp->height; row++)
		for(col=0; col<bmp->width; col++)
			//if(bmp->data[(row*bmp->width)+col])
				putpixel(x+col,y+row,bmp->data[(row*bmp->width)+col]);
}

//----------------------- The Ship object's functions --------------------
Ship::Ship(int x, int y, char *file)
{
	X = x;
	Y = y;
	oldX=X;
	oldY=Y;
	load_bmp(file,&bmp);
	Size = bmp.width;
};
//--------------------------- Ship Draw --------------------------------
void Ship::Draw(void)
{
	// cover over the old ship
	setcolor(0);
	setfillstyle(SOLID_FILL, 0);
	if(X == oldX && Y < oldY)  // straight up
		bar(X, Y+bmp.height, X+bmp.width, oldY+bmp.height);
	else if(X == oldX && Y > oldY)  // straight down
		bar(X, oldY, X+bmp.width, Y);
	else if(X < oldX && Y == oldY) // straight left
		bar(X+bmp.width, Y, oldX+bmp.width, Y+bmp.height);
	else if(X > oldX && Y == oldY) // straight right
		bar(oldX, Y, X, Y+bmp.height);
	else if(X > oldX && Y > oldY) // down and right
	{
		bar(oldX, oldY, oldX+bmp.width, Y);
		bar(oldX, Y, X, oldY+bmp.height);
	}
	else if(X > oldX && Y < oldY) // up and right
	{
		bar(oldX, oldY, X, oldY+bmp.height);
		bar(X, Y+bmp.height, oldX+bmp.width, oldY+bmp.height);
	}
	else if(X < oldX && Y < oldY) // up and left
	{
		bar(X+bmp.width, oldY, oldX+bmp.width, oldY+bmp.height);
		bar(oldX, Y+bmp.height, X+bmp.width, oldY+bmp.height);
	}
	else if(X < oldX && Y > oldY) // down and left
	{
		bar(oldX, oldY, oldX+bmp.width, Y);
		bar(X+bmp.width, Y, oldX+bmp.width, oldY+bmp.width);
	}


	// draw the new ship
	flushall();
	draw_bitmap(&bmp,X,Y);
}
//------------------------------- Ship Move ---------------------------
void Ship::Move(void)
{
	oldX=X;
	oldY=Y;
	X += XSpeed;
	Y += YSpeed;
	if(X > getmaxx()) X=0-(int)bmp.width;
	if(X < 0-(int)bmp.width) X=getmaxx();
	if(Y > getmaxy()) Y=0-(int)bmp.height;
	if(Y < 0-(int)bmp.height) Y=getmaxy();
}